/*
gcc -I/local/src/postgresql-7.0.3/src/include -I/local/src/postgresql-7.0.3/src/backend   \
	-O2 -m486 -pipe -Wall -Wmissing-prototypes -Wmissing-declarations -I/local/src/postgresql-7.0/src/interfaces/libpq \
	-I/local/src/postgresql-7.0/src/include -fpic -DPIC   -c -o \
	XXX.o XXX.c

ld -x -shared -o XXX.so XXX.o
rm XXX.o
*/

#include <stdio.h>
#include "postgres.h"
#include "utils/builtins.h"

int am_int_bit_and(int, int);
int am_int_bit_or(int, int);
int am_int_bit_xor(int, int);
int am_int_bit_not(int);

/* $a & $b And Bits that are set in both $a and $b are set.  */
int am_int_bit_and(int arg1, int arg2)  {
	return(arg1 & arg2);
}

/* $a | $b Or Bits that are set in either $a or $b are set.  */
int am_int_bit_or(int arg1, int arg2)  {
	return(arg1 | arg2);
}

/* $a ^ $b Xor Bits that are set in $a or $b but not both are set.   */
int am_int_bit_xor(int arg1, int arg2)  {
	return(arg1 ^ arg2);
}

/* ~ $a Not Bits that are set in $a are not set, and vice versa.   */
int am_int_bit_not(int arg1)  {
	return(~ arg1);
}
